<?php
/* Autor...: Grupo Deltron S.A. */
/* Esquema.: cr_alfa_extension_15082014.xml */
/* Generado: 2014-08-26 22:08:10 */

/* Mantenimiento de los registros de la tabla cr_cliente_file */
abstract class BaseCr_cliente_fileDP extends Cr_cliente_fileBV
{
    /* Constructor ( Establece los valores desde un objeto Cr_cliente_fileBN ) */
    public function __construct( Cr_cliente_fileBN $o_Cr_cliente_fileBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_Cr_cliente_fileBN ) )
        {
            $this->setByBN( $o_Cr_cliente_fileBN );
        }
    }

    /* Establece los valores desde un objeto Cr_cliente_fileBN */
    public function setByBN( Cr_cliente_fileBN $o_Cr_cliente_fileBN )
    {
        if ( !is_null( $o_Cr_cliente_fileBN->getIdClienteFile() ) )
        {
            $this->setIdClienteFile( $o_Cr_cliente_fileBN->getIdClienteFile() );
        }
        if ( !is_null( $o_Cr_cliente_fileBN->getIdCliente() ) )
        {
            $this->setIdCliente( $o_Cr_cliente_fileBN->getIdCliente() );
        }
        if ( !is_null( $o_Cr_cliente_fileBN->getFileNumero() ) )
        {
            $this->setFileNumero( $o_Cr_cliente_fileBN->getFileNumero() );
        }
        if ( !is_null( $o_Cr_cliente_fileBN->getEstado() ) )
        {
            $this->setEstado( $o_Cr_cliente_fileBN->getEstado() );
        }
        if ( !is_null( $o_Cr_cliente_fileBN->getNombreFile() ) )
        {
            $this->setNombreFile( $o_Cr_cliente_fileBN->getNombreFile() );
        }
        if ( !is_null( $o_Cr_cliente_fileBN->getFechaEliminado() ) )
        {
            $this->setFechaEliminado( $o_Cr_cliente_fileBN->getFechaEliminado() );
        }
        if ( !is_null( $o_Cr_cliente_fileBN->getUsuarioEliminado() ) )
        {
            $this->setUsuarioEliminado( $o_Cr_cliente_fileBN->getUsuarioEliminado() );
        }
        if ( !is_null( $o_Cr_cliente_fileBN->getEliminado() ) )
        {
            $this->setEliminado( $o_Cr_cliente_fileBN->getEliminado() );
        }
        if ( !is_null( $o_Cr_cliente_fileBN->getFechaRegistro() ) )
        {
            $this->setFechaRegistro( $o_Cr_cliente_fileBN->getFechaRegistro() );
        }
        if ( !is_null( $o_Cr_cliente_fileBN->getUsuarioRegistro() ) )
        {
            $this->setUsuarioRegistro( $o_Cr_cliente_fileBN->getUsuarioRegistro() );
        }
        if ( !is_null( $o_Cr_cliente_fileBN->getIdtipofile() ) )
        {
            $this->setIdtipofile( $o_Cr_cliente_fileBN->getIdtipofile() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_cr_cliente_fileFN = new Cr_cliente_fileFN();
        $o_cr_cliente_fileBN = $o_cr_cliente_fileFN->selectByPk( $this->getIdClienteFile() );
        if ( is_null( $o_cr_cliente_fileBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO cr_cliente_file ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdClienteFile() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdClienteFile";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdClienteFile()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCliente() ) )
            {
                $s_SQLQuery1 .= $s_Separator."idcliente";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCliente()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFileNumero() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FileNumero";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFileNumero()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreFile() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NombreFile";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNombreFile()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaEliminado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaEliminado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaEliminado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioEliminado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioEliminado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioEliminado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEliminado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Eliminado";
                $s_SQLQuery2 .= $s_Separator."".$this->getEliminado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaRegistro() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaRegistro";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioRegistro() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioRegistro";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdtipofile() ) )
            {
                $s_SQLQuery1 .= $s_Separator."idtipofile";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdtipofile()."";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = $o_cr_cliente_fileFN->getConnect();
            $o_Result = mysql_query( $s_SQLQuery, $o_Resource );
            if ( $o_Result === false )
            {
                throw new Exception( mysql_error() );
            }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        $o_cr_cliente_fileFN = new Cr_cliente_fileFN();
        $o_cr_cliente_fileBN = $o_cr_cliente_fileFN->selectByPk( $this->getIdClienteFile() );
        if ( !is_null( $o_cr_cliente_fileBN ) )
        {
            $s_SQLQuery = "UPDATE cr_cliente_file SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCliente() ) && $this->getIdCliente() !== $o_cr_cliente_fileBN->getIdCliente() )
            {
                $s_SQLQuery .= $s_Separator."idcliente = ".$this->getIdCliente()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFileNumero() ) && $this->getFileNumero() !== $o_cr_cliente_fileBN->getFileNumero() )
            {
                $s_SQLQuery .= $s_Separator."FileNumero = '".$this->getFileNumero()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) && $this->getEstado() !== $o_cr_cliente_fileBN->getEstado() )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreFile() ) && $this->getNombreFile() !== $o_cr_cliente_fileBN->getNombreFile() )
            {
                $s_SQLQuery .= $s_Separator."NombreFile = '".$this->getNombreFile()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaEliminado() ) && $this->getFechaEliminado() !== $o_cr_cliente_fileBN->getFechaEliminado() )
            {
                $s_SQLQuery .= $s_Separator."FechaEliminado = '".$this->getFechaEliminado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioEliminado() ) && $this->getUsuarioEliminado() !== $o_cr_cliente_fileBN->getUsuarioEliminado() )
            {
                $s_SQLQuery .= $s_Separator."UsuarioEliminado = '".$this->getUsuarioEliminado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEliminado() ) && $this->getEliminado() !== $o_cr_cliente_fileBN->getEliminado() )
            {
                $s_SQLQuery .= $s_Separator."Eliminado = ".$this->getEliminado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaRegistro() ) && $this->getFechaRegistro() !== $o_cr_cliente_fileBN->getFechaRegistro() )
            {
                $s_SQLQuery .= $s_Separator."FechaRegistro = '".$this->getFechaRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioRegistro() ) && $this->getUsuarioRegistro() !== $o_cr_cliente_fileBN->getUsuarioRegistro() )
            {
                $s_SQLQuery .= $s_Separator."UsuarioRegistro = '".$this->getUsuarioRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdtipofile() ) && $this->getIdtipofile() !== $o_cr_cliente_fileBN->getIdtipofile() )
            {
                $s_SQLQuery .= $s_Separator."idtipofile = ".$this->getIdtipofile()."";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdClienteFile = ".$this->getIdClienteFile().";";
            $o_Resource = $o_cr_cliente_fileFN->getConnect();
            if ( mysql_query( $s_SQLQuery, $o_Resource ) === false )
            {
                throw new Exception( mysql_error() );
            }
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $o_cr_cliente_fileFN = new Cr_cliente_fileFN();
        $o_cr_cliente_fileBN = $o_cr_cliente_fileFN->selectByPk( $this->getIdClienteFile() );
        if ( !is_null( $o_cr_cliente_fileBN ) )
        {
            $s_SQLQuery = "DELETE FROM cr_cliente_file WHERE  IdClienteFile = ".$this->getIdClienteFile().";";
            $o_Resource = $o_cr_cliente_fileFN->getConnect();
            if ( mysql_query( $s_SQLQuery, $o_Resource ) === false )
            {
                throw new Exception( mysql_error() );
            }
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Selecciona un registro por la llave primaria */
    public static function selectByPk( $i_IdClienteFile )
    {
        $o_cr_cliente_fileFN = new Cr_cliente_fileFN();
        if ( $o_cr_cliente_fileBN = $o_cr_cliente_fileFN->selectByPK( $i_IdClienteFile ) )
        {
            $o_cr_cliente_fileDP = new cr_cliente_fileDP();
            $o_cr_cliente_fileDP->setIdClienteFile( $o_cr_cliente_fileBN->getIdClienteFile(), false );
            $o_cr_cliente_fileDP->setIdCliente( $o_cr_cliente_fileBN->getIdCliente(), false );
            $o_cr_cliente_fileDP->setFileNumero( $o_cr_cliente_fileBN->getFileNumero(), false );
            $o_cr_cliente_fileDP->setEstado( $o_cr_cliente_fileBN->getEstado(), false );
            $o_cr_cliente_fileDP->setNombreFile( $o_cr_cliente_fileBN->getNombreFile(), false );
            $o_cr_cliente_fileDP->setFechaEliminado( $o_cr_cliente_fileBN->getFechaEliminado(), false );
            $o_cr_cliente_fileDP->setUsuarioEliminado( $o_cr_cliente_fileBN->getUsuarioEliminado(), false );
            $o_cr_cliente_fileDP->setEliminado( $o_cr_cliente_fileBN->getEliminado(), false );
            $o_cr_cliente_fileDP->setFechaRegistro( $o_cr_cliente_fileBN->getFechaRegistro(), false );
            $o_cr_cliente_fileDP->setUsuarioRegistro( $o_cr_cliente_fileBN->getUsuarioRegistro(), false );
            $o_cr_cliente_fileDP->setIdtipofile( $o_cr_cliente_fileBN->getIdtipofile(), false );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return $o_cr_cliente_fileDP;
    }
}
?>